package bin.turtle;

import lib.turtle.Helper;
import lib.turtle.TurtleAppBase;

class Excavate extends TurtleAppBase {
	private var x:Int = 0;
	private var y:Int = 0;
	private var z:Int = 0;

	public function new() {
		super(init, turtleFunction);
	}

	private function init() {
		if (handle.args.length < 2) {
			handle.writeLine("Usage: excavate <front> <right> <down>");
			handle.close(false);
		}

		var parsedX = Std.parseInt(handle.args[0]);
		var parsedY = Std.parseInt(handle.args[1]);
		var parsedZ = Std.parseInt(handle.args[2]);

		if (parsedX == null || parsedY == null || parsedZ == null) {
			handle.writeLine("Invalid arguments");
			handle.close(false);
		}

		this.x = parsedX;
		this.y = parsedY;
		this.z = parsedZ;
	}

	private function turtleFunction() {
		for (z in 0...this.z) {
			for (y in 0...this.y) {
				for (x in 0...this.x) {
					kernel.turtle.Turtle.dig(Down);

					if (x < this.x - 1) {
						kernel.turtle.Turtle.forward();
					}
				}

				if (y < this.y - 1) {
					if (y % 2 == 0) {
						kernel.turtle.Turtle.turnRight();
						kernel.turtle.Turtle.forward();
						kernel.turtle.Turtle.turnRight();
					} else {
						kernel.turtle.Turtle.turnLeft();
						kernel.turtle.Turtle.forward();
						kernel.turtle.Turtle.turnLeft();
					}
				}
			}

			kernel.turtle.Turtle.dig(Down);
			kernel.turtle.Turtle.down();

			Helper.times(kernel.turtle.Turtle.turnLeft, 2);
		}

		handle.close(true);
	}
}
